%module ABAC

// Accessing these overloaded functions confuses perl and python.
// We ignore the string version and rename the char * version to
// member_name.  The bare name takes an open file.

%ignore ABAC::ID::write_cert(const std::string&);
%rename(write_cert_name) ABAC::ID::write_cert(const char *);

%ignore ABAC::ID::write_privkey(const std::string&);
%rename(write_privkey_name) ABAC::ID::write_privkey(const char *);

%ignore ABAC::Attribute::write(const std::string&);
%rename(write_name) ABAC::Attribute::write(const char *);

%rename(ID_chunk) ABAC::ID::ID(abac_chunk_t);

%{
#include "abac.hh"
using namespace ABAC;
%}

%include "language.i"

%ignore std::vector<ABAC::Credential>::vector(size_type); 
%ignore std::vector<ABAC::Credential>::resize(size_type);
%ignore std::vector<ABAC::Credential>::pop(); 
%include "std_vector.i"

namespace std {
    %template(CredentialVector) vector<ABAC::Credential>;
};

%include "abac.h"
%include "abac.hh"
